package pp.s1184725.boppi;

import java.util.EmptyStackException;

public class DebugCachingSymbolTable<T extends Type> extends CachingSymbolTable<T> {

	@Override
	public void openScope() {
		super.openScope();
	}

	@Override
	public void openFunctionScope() {
		System.out.println(this.getClass().getName() + ": entering scope depth " + functionDepth);
		super.openFunctionScope();
	}

	@Override
	public void closeScope() throws EmptyStackException {
		super.closeScope();
	}

	@Override
	public void closeFunctionScope() throws EmptyStackException {
		System.out.println(this.getClass().getName() + ": leaving scope depth " + functionDepth);
		super.closeFunctionScope();
	}

	@Override
	public Variable<T> put(String id, T type) throws Exception, EmptyStackException {
		System.out.println(this.getClass().getName() + ": declaring '" + id + "' at scope " + functionDepth);
		return super.put(id, type);
	}

	@Override
	public boolean has(String id) throws EmptyStackException {
		return super.has(id);
	}

	@Override
	public Variable<T> get(String id) throws Exception, EmptyStackException {
		System.out.println(this.getClass().getName() + ": retrieving '" + id + "' (depth "
				+ symbolCache.get(id).getDepth() + ") at scope " + functionDepth);
		return super.get(id);
	}

	@Override
	public int getLocalDataSize() {
		return super.getLocalDataSize();
	}

	@Override
	public int getFunctionDepth() {
		return super.getFunctionDepth();
	}

}
